import type { Location, NavigationType, RouteProps } from 'react-router-dom';
import { SlotRegistry } from '@teambit/harmony';
import type { SSR } from '@teambit/ui';
import { RouteSlot } from '@teambit/ui-foundation.ui.react-router.slot-router';
import { Routing } from './routing-method';
export type LocationListener = (location: Location, action: NavigationType) => void;
type RouteChangeSlot = SlotRegistry<LocationListener>;
type RenderContext = {
    initialLocation?: string;
};
export declare class ReactRouterUI {
    /**
     * route slot.
     */
    private routeSlot;
    /**
     *
     */
    private routeChangeListener;
    private routingMode;
    constructor(
    /**
     * route slot.
     */
    routeSlot: RouteSlot, 
    /**
     *
     */
    routeChangeListener: RouteChangeSlot);
    /**
     * render all slot routes.
     */
    renderRoutes(routes: RouteProps[]): JSX.Element;
    /** decides how navigation is stored and applied.
     * Url - updates the `window.location.pathname`.
     * Hash - updates `window.location.hash`.
     * InMemory - store state internally and don't update the browser.
     */
    setRoutingMode(routing: Routing): void;
    /**
     * register a new route.
     */
    register(route: RouteProps): this;
    registerListener(listener: LocationListener): void;
    /**
     * change browser location
     */
    navigateTo: (path: Location | string, action?: NavigationType) => void;
    private navigate?;
    private handleLocationChange;
    private RoutingContext;
    private ServerRouting;
    renderPlugin: SSR.RenderPlugin<RenderContext>;
    static slots: (((registerFn: () => string) => SlotRegistry<RouteProps>) | ((registerFn: () => string) => SlotRegistry<LocationListener>))[];
    static runtime: import("@teambit/harmony").RuntimeDefinition;
    static provider(deps: any, config: any, [routeSlot, routeChangeSlot]: [RouteSlot, RouteChangeSlot]): Promise<ReactRouterUI>;
}
export {};
