"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReactRouterUI = void 0;
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function () {
    return data;
  };
  return data;
}
function _harmony() {
  const data = require("@teambit/harmony");
  _harmony = function () {
    return data;
  };
  return data;
}
function _ui() {
  const data = require("@teambit/ui");
  _ui = function () {
    return data;
  };
  return data;
}
function _reactRouter() {
  const data = require("./react-router.aspect");
  _reactRouter = function () {
    return data;
  };
  return data;
}
function _routeContext() {
  const data = require("./route-context");
  _routeContext = function () {
    return data;
  };
  return data;
}
function _routingMethod() {
  const data = require("./routing-method");
  _routingMethod = function () {
    return data;
  };
  return data;
}
function _LocationHooks() {
  const data = require("./LocationHooks");
  _LocationHooks = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
class ReactRouterUI {
  constructor(
  /**
   * route slot.
   */
  routeSlot,
  /**
   *
   */
  routeChangeListener) {
    this.routeSlot = routeSlot;
    this.routeChangeListener = routeChangeListener;
    _defineProperty(this, "routingMode", _routingMethod().Routing.url);
    /**
     * change browser location
     */
    _defineProperty(this, "navigateTo", (path, action) => {
      const state = typeof path !== 'string' ? path.state : undefined;
      switch (action) {
        case 'POP':
          return;
        // TBD;
        case 'REPLACE':
          this.navigate?.(path, {
            replace: true,
            state
          });
          return;
        case 'PUSH':
        default:
          this.navigate?.(path, {
            state
          });
      }
    });
    _defineProperty(this, "navigate", undefined);
    _defineProperty(this, "handleLocationChange", (location, action) => {
      const listeners = this.routeChangeListener.values();
      listeners.forEach(listener => listener(location, action));
    });
    _defineProperty(this, "RoutingContext", ({
      children,
      renderCtx
    }) => {
      return /*#__PURE__*/_react().default.createElement(_routeContext().RouteContext, {
        reactRouterUi: this,
        routing: this.routingMode,
        location: renderCtx?.initialLocation
      }, children, /*#__PURE__*/_react().default.createElement(_LocationHooks().LocationHooks, {
        onLocationChange: this.handleLocationChange,
        onNavigatorChange: nav => this.navigate = nav
      }));
    });
    _defineProperty(this, "ServerRouting", ({
      children,
      renderCtx
    }) => {
      return /*#__PURE__*/_react().default.createElement(_routeContext().RouteContext, {
        reactRouterUi: this,
        routing: _routingMethod().Routing.static,
        location: renderCtx?.initialLocation
      }, children, /*#__PURE__*/_react().default.createElement(_LocationHooks().LocationHooks, {
        onLocationChange: this.handleLocationChange,
        onNavigatorChange: nav => this.navigate = nav
      }));
    });
    _defineProperty(this, "renderPlugin", {
      browserInit: () => {
        const initialLocation = `${window.location.pathname}${window.location.search}${window.location.hash}`;
        return {
          initialLocation
        };
      },
      serverInit: ({
        browser
      }) => {
        const initialLocation = browser?.location.url;
        return {
          initialLocation
        };
      },
      reactClientContext: this.RoutingContext,
      reactServerContext: this.ServerRouting
    });
  }

  /**
   * render all slot routes.
   */
  renderRoutes(routes) {
    return /*#__PURE__*/_react().default.createElement(_routeContext().RootRoute, {
      routeSlot: this.routeSlot,
      rootRoutes: routes
    });
  }

  /** decides how navigation is stored and applied.
   * Url - updates the `window.location.pathname`.
   * Hash - updates `window.location.hash`.
   * InMemory - store state internally and don't update the browser.
   */
  setRoutingMode(routing) {
    this.routingMode = routing;
  }

  /**
   * register a new route.
   */
  register(route) {
    this.routeSlot.register(route);
    return this;
  }
  registerListener(listener) {
    this.routeChangeListener.register(listener);
  }
  static async provider(deps, config, [routeSlot, routeChangeSlot]) {
    return new ReactRouterUI(routeSlot, routeChangeSlot);
  }
}
exports.ReactRouterUI = ReactRouterUI;
_defineProperty(ReactRouterUI, "slots", [_harmony().Slot.withType(), _harmony().Slot.withType()]);
_defineProperty(ReactRouterUI, "runtime", _ui().UIRuntime);
_reactRouter().ReactRouterAspect.addRuntime(ReactRouterUI);

//# sourceMappingURL=react-router.ui.runtime.js.map